<template>
  <Dialog v-model="dialogVisible" :title="dialogTitle" width="800">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :model="formData"
      :rules="formRules"
      label-width="110px"
    >
      <el-form-item label="组件名称" prop="componentName">
        <el-input v-model="formData.componentName" placeholder="请输入组件名称" style="width: 300px" />
      </el-form-item>
      <el-form-item label="组件路径" prop="componentFilePath" >
        <el-input v-model="formData.componentFilePath" placeholder="请输入组件路径" style="width: 300px"/>
      </el-form-item>
      <el-form-item label="组件类型" prop="componentCategory">
        <el-select v-model="formData.componentCategory" style="width: 300px">
          <el-option v-for="dict in getStrDictOptions(DICT_TYPE.COCKPIT_COMPONENT_TYPE)"
                     :key="dict.value"
                     :label="dict.label"
                     :value="dict.value"
          />
        </el-select>
      </el-form-item>

      <el-form-item label="组件缩略图" prop="componentThumbnail">
        <UploadImg
          :limit="1"
          v-model="formData.componentThumbnail"
          :fileSize="5"
        />
      </el-form-item>

    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>

<script setup lang="ts">
import * as cockpitApi from '@/api/system/cockpitComponent/index'
import { DICT_TYPE, getIntDictOptions, getStrDictOptions } from '@/utils/dict'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗
const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  componentName:'',
  componentFilePath:'',
  componentThumbnail:'',
  componentCategory:''
})
const formRules = reactive({
  componentName: [{ required: true, message: '组件名称不能为空', trigger: 'blur' }],
  componentFilePath: [{ required: true, message: '组件路径不能为空', trigger: 'blur' }],
  componentCategory: [{ required: true, message: '组件类型不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref


const open=async(type:string,id?:number)=>{
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await cockpitApi.selectUiComponentById(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调

const submitForm=async()=>{
//   校验表单
  if(!formRef) return
  const valid =await formRef.value.validate()
  if(!valid) return
//   提交请求
  formLoading.value = true
  try{
    const data=formData.value
    if(formType.value == 'create'){
      await cockpitApi.insertUiComponent(data)
      message.success(t('common.createSuccess'))
    }else{
      await cockpitApi.updateUiComponent(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    componentName:'',
    componentFilePath:'',
    componentThumbnail:'',
    componentCategory:''
  }
  formRef.value?.resetFields()
}

</script>

<style scoped lang="scss">

</style>
